
QGIS Application - Bug report #11371

Map Composer: group + move + ungroup + undo = crash

2014-10-09 07:44 AM - Roy Roge

Status: Closed

Priority: High

Assignee: Sandro Santilli

Category: Map Composer/Printing

Affected QGIS version:2.14.3 Regression?: No

Operating System: Windows , Linux Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:Yes Copied to github as #: 19662

Description

Using the map composer add two rectangles,

group them, move the grouped, ungroup them,

click the undo arrow, you get the program to crash,

thanks,

Roy.

Related issues:

Related to QGIS Application - Bug report # 11351: [composer] combinations of ... Closed 2014-10-08

Associated revisions

Revision a211c982 - 2016-06-17 01:41 PM - Sandro Santilli

Allow to undo/redo composer grouping/ungrouping

Fixes #11371 (crash on ungrouping after moving the group) and more

undo/redo related issues.

Enable pending test for the crash (now passing) and add many more

undo/redo related ones (including signals testing).

Includes a new QgsGroupUngroupItemsCommand class

and its SIP bindings.

Revision df8dca2e - 2016-06-17 04:49 PM - Sandro Santilli

Fix crash in composer on ungrouping after group move.

Closes #11371.

Adds support for undo/redo grouping/ungrouping operations.

Enable pending test for the crash (now passing) and add many more

undo/redo related ones (including signals testing).

Includes a new QgsGroupUngroupItemsCommand class

and its SIP bindings.
History

#1 - 2014-10-10 04:21 AM - Giovanni Manghi

- Priority changed from High to Severe/Regression

on qgis 2.4 seems ok. Crash confirmed on master.

#2 - 2014-10-12 01:37 PM - Nyall Dawson

- Priority changed from Severe/Regression to High

Actually 2.4 and below are affected too, so reducing this from a blocker to high. It's a serious issue though.

#3 - 2016-01-19 04:50 AM - Sandro Santilli

- Status changed from Open to Feedback

I cannot reproduce on current master (2.14-pre, commit:69cb0c4ed3174946c82e32dad4af5a12275079fc) -- can anyone ?

#4 - 2016-01-19 10:12 AM - Nyall Dawson

- Status changed from Feedback to Open

Still present. I can't fix this one without major api breaks.

#5 - 2016-06-09 08:02 AM - Sandro Santilli

I still cannot reproduce with 2.16-dev d1cac84, how do you "group"/"ungroup" ? I'm using the "select/move" tool for that, clicking outside the group to

"ungroup", but I suspect it's not what you mean...

#6 - 2016-06-09 08:03 AM - Sandro Santilli

Ah, found the "group" and "ungroup" button, crash reproduced in d1cac842d323ffb13a606e8d598dd0d8af4ade72 (2.16-dev).

#7 - 2016-06-09 08:05 AM - Sandro Santilli

- Operating System changed from windows linux to Windows , Linux

- Affected QGIS version changed from master to 2.14.3

- Target version set to Version 2.14

- Assignee set to Sandro Santilli

- Status changed from Open to In Progress

Also happens with 2.14.3 LTR

#8 - 2016-06-09 08:09 AM - Sandro Santilli

2024-04-28 2/4



For the record: this ticket already has an ecoded test, just #if-0'ed out, in tests/src/core/testqgscomposergroup.cpp

#9 - 2016-06-09 08:39 AM - Sandro Santilli

The problem is that an object (the group) is removed while it would be needed to undo the grouping itself.

Besides, the group-move is not pushed to the undo stack so a quick fix of the crash done by avoiding the destruction of the group results in undo operation

never undoing a grouping or ungrouping.

#10 - 2016-06-09 10:02 AM - Sandro Santilli

I've started work on this here: https://github.com/qgis/QGIS/pull/3190

#11 - 2016-06-10 04:36 AM - Sandro Santilli

- Pull Request or Patch supplied changed from No to Yes

- % Done changed from 0 to 80

PR is ready for test. Roy: could you test ? Nyall: could you review ?

#12 - 2016-06-17 04:42 AM - Sandro Santilli

- Status changed from In Progress to Closed

Fixed in changeset commit:"a211c982cfe6c92d4ba9e5fb79a3124c7f3e4a19".

#13 - 2016-06-17 04:46 AM - Sandro Santilli

- Status changed from Closed to Reopened

Reopened to backport to 2.14 (fix so far was only gone to master aka 2.15.0dev)

#14 - 2016-06-17 07:52 AM - Sandro Santilli

- Status changed from Reopened to Closed

Fixed in changeset commit:"df8dca2e53390012126c42f97467023f2eb912eb".

#15 - 2016-06-18 12:19 AM - Roy Roge

- % Done changed from 80 to 100

Sandro Santilli wrote:

PR is ready for test. Roy: could you test ?
Thanks Sandro, I tesded both 2.15 and 2.14 nightly

and cannot reproduce the crash, so it's working properly

Roy.
